package org.insa.graphs.algorithm.shortestpath;

import org.insa.graphs.model.Node;
import org.insa.graphs.model.Arc;

public class Label implements java.lang.Comparable<Label>{
	private Node sommetCourant;
	private boolean isMarque;
	private double cout;
	private Arc pere;
	

	
	public Label(Node sommetCourant)
	{
		this.sommetCourant=sommetCourant;
		this.setCout(Double.POSITIVE_INFINITY);
		this.setMarque(false);
		this.setPere(null);
	}
	

	public Arc getPere() {
		return pere;
	}

	public void setPere(Arc pere) {
		this.pere = pere;
	}

	public boolean isMarque() {
		return isMarque;
	}

	public void setMarque(boolean isMarque) {
		this.isMarque = isMarque;
	}

	public Node getSommetCourant() {
		return sommetCourant;
	}


	public double getCout() {
		return cout;
	}
	
	public int compareTo(Label B)
	{
		if(this.getCoutTotal()<B.getCoutTotal())
		{
			return -1;
		}
		else if(this.getCoutTotal()==B.getCoutTotal())
		{
			if(this.getCoutEstime()<B.getCoutEstime())
			{
				return -1;
			}
			else if(this.getCoutEstime()>B.getCoutEstime())
			{
				return 1;
			}
			else
			{
				return 0;
			}
		}
		else
		{
			return 1;
		}
	}

	public void setCout(double cout) {
		this.cout = cout;
	}
	
	public double getCoutEstime()
	{
		return 0;
	}
	
	public double getCoutTotal()
	{
		return cout+this.getCoutEstime();
	}
}
